function MapExtension.AE.Init(handle, addonIdentifier)
	if addonIdentifier == MapExtensionAddon.identifier then
		MapExtension.AE.InitSettings()
		MapExtension.AE.Language = Inspect.System.Language()

		MapExtension.AE.UI.Context = UI.CreateContext(MapExtensionAddon.identifier)
		MapExtension.AE.UI.Button = MapExtension.GUI.CreateButton(MapExtension.AE.UI.Context, iif(MINIMAPDOCKER, nil, MapExtensionUISettings.button.x), iif(MINIMAPDOCKER, nil, MapExtensionUISettings.button.y), 32, 32, 0, "button")
		if MINIMAPDOCKER then
			MINIMAPDOCKER.Register(MapExtensionAddon.toc.Name, MapExtension.AE.UI.Button, MapExtension.AE.ToggleWindow)
		else
			MapExtension.EGUI.AttachDragFrame(MapExtension.AE.UI.Button, false, "button", false)
		end
		MapExtension.AE.UI.Button.Event.LeftClick = MapExtension.AE.ToggleWindow

		MapExtension.AE.UI.Window = UI.CreateFrame("RiftWindow", "", MapExtension.AE.UI.Context)
		MapExtension.AE.UI.Window:SetVisible(MapExtension.AE.Visible)
		MapExtension.AE.UI.Window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", MapExtensionUISettings.window.x, MapExtensionUISettings.window.y)
		MapExtension.AE.UI.Window:SetWidth(MapExtensionUISettings.window.width)
		MapExtension.AE.UI.Window:SetHeight(MapExtensionUISettings.window.height)
		MapExtension.AE.UI.Window:SetTitle(string.upper(MapExtensionAddon.toc.Name))
		MapExtension.AE.UI.Window:SetController("content")
		MapExtension.AE.UI.Window:SetLayer(100)
		MapExtension.EGUI.AttachDragFrame(MapExtension.AE.UI.Window, true, "window", true)
		MapExtension.EGUI.AttachResizableFrame(MapExtension.AE.UI.Window, "window", 400, 320)

		MapExtension.AE.UI.MapTexture = { active = 0 }
		MapExtension.AE.UI.MapTexture[0] = MapExtension.GUI.CreateTextureView(MapExtension.AE.UI.Window, 0, 0, 10, 30, 10, 1, "img/map/0/", 14464, 7616, 256, { x = 7759, y = 4384 })
		MapExtension.AE.UI.MapTexture[0]:SetBackgroundColor(.234375, .2421875, .234375)
		table.insert(MapExtension.AE.UI.MapTexture[0].MousePosition, MapExtension.AE.OnMousePosition)
		MapExtension.AE.UI.MapTexture[1] = MapExtension.GUI.CreateTextureView(MapExtension.AE.UI.Window, 1, 0, 10, 30, 10, 1, "img/map/1/", 20480, 15360, 256, { x = 10240, y = 7680 })
		MapExtension.AE.UI.MapTexture[1]:SetBackgroundColor(.234375, .2421875, .234375)
		table.insert(MapExtension.AE.UI.MapTexture[1].MousePosition, MapExtension.AE.OnMousePosition)

		MapExtension.GUI.CreateTileTexture(MapExtension.AE.UI.Window, 0, 10, 30, 10, 17, 17, 2, "img/border.png", "img/borderh.png", "img/borderv.png")
		MapExtension.AE.UI.Coordinates = MapExtension.GUI.CreateText(MapExtension.AE.UI.Window, "BOTTOMCENTER", 0, -4, "[]", 100, nil, {.75, .75, .75, 1})
		MapExtension.GUI.CreateText(MapExtension.AE.UI.Window, "BOTTOMRIGHT", -10, -5, "v." .. MapExtensionAddon.toc.Version, 100, nil, {.5, .5, .5, 1})
		MapExtension.GUI.CreateRiftButton(MapExtension.AE.UI.Window, 4, -41, 2).Event.LeftPress = MapExtension.AE.ToggleWindow

		MapExtension.AE.UI.Switch = MapExtension.GUI.CreateButton(MapExtension.AE.UI.Window, -150, -3, 24, 24, 100, "switch", "BOTTOMCENTER")
		MapExtension.AE.UI.Switch.Event.LeftClick = function() MapExtension.AE.OnSwitchMap() end

		MapExtension.AE.UI.Lock = MapExtension.GUI.CreateButton(MapExtension.AE.UI.Window, -120, -3, 24, 24, 100, "lock", "BOTTOMCENTER", true)
		MapExtension.AE.UI.Lock.SetState(MapExtensionUISettings.flags.lock)
		MapExtension.AE.UI.Lock.Event.LeftClick = function() MapExtensionUISettings.flags.lock = not MapExtensionUISettings.flags.lock MapExtension.AE.UI.Lock.state = MapExtensionUISettings.flags.lock end

		MapExtension.AE.UI.Options = MapExtension.GUI.CreateButton(MapExtension.AE.UI.Window, -90, -3, 24, 24, 100, "options", "BOTTOMCENTER")
		MapExtension.AE.UI.Options.Event.LeftClick = function() MapExtension.Menu.Tracking.ToggleWindow(false) MapExtension.Menu.Achievements.ToggleWindow(false) MapExtension.Menu.Options.ToggleWindow() end
		MapExtension.Menu.Options.Init(MapExtension.AE.UI.Options)

		MapExtension.AE.UI.Achievements = MapExtension.GUI.CreateButton(MapExtension.AE.UI.Window, 90, -3, 24, 24, 100, "achievements", "BOTTOMCENTER")
		MapExtension.AE.UI.Achievements.Event.LeftClick = function() MapExtension.Menu.Tracking.ToggleWindow(false) MapExtension.Menu.Options.ToggleWindow(false) MapExtension.Menu.Achievements.ToggleWindow() end
		MapExtension.Menu.Achievements.Init(MapExtension.AE.UI.Achievements)

		MapExtension.AE.UI.Tracking = MapExtension.GUI.CreateButton(MapExtension.AE.UI.Window, 120, -3, 24, 24, 100, "tracking", "BOTTOMCENTER")
		MapExtension.AE.UI.Tracking.Event.LeftClick = function() MapExtension.Menu.Achievements.ToggleWindow(false) MapExtension.Menu.Options.ToggleWindow(false) MapExtension.Menu.Tracking.ToggleWindow() end
		MapExtension.Menu.Tracking.Init(MapExtension.AE.UI.Tracking)

		MapExtension.AE.LoadData()
		MapExtension.Messenger.Send(MapExtension.Messenger.MessageVersion, MapExtensionAddon.toc.Version)

		Command.Console.Display("general", true, "<font color=\"#AD48FB\">" .. MapExtensionAddon.name .. " ver." .. MapExtensionAddon.toc.Version .. MapExtension.Language.Load1[MapExtension.AE.Language] .. MapExtension.AE.Command .. MapExtension.Language.Load2[MapExtension.AE.Language] .. "</font>", true)
	end
end

function MapExtension.AE.OnMousePosition(isInner, x, y) 
	MapExtension.AE.CoordinatesType = isInner
	local position = MapExtension.AE.Coordinates
	if isInner then
		position = { x = x, y = y }
	end
	MapExtension.AE.ShowCoordinates(position)
end

function MapExtension.AE.InitSettings()
	if MapExtensionUISettings == nil then MapExtensionUISettings = {} end
	if MapExtensionUISettings.button == nil then MapExtensionUISettings.button = { x = math.floor(UIParent:GetWidth() / 2), y = math.floor(UIParent:GetHeight() / 2) } end
	if MapExtensionUISettings.window == nil then MapExtensionUISettings.window = { x = math.floor(UIParent:GetWidth() / 4), y = math.floor(UIParent:GetHeight() / 4), width = math.floor(UIParent:GetWidth() / 2), height = math.floor(UIParent:GetHeight() / 2) } end
	if MapExtensionUISettings.achievements == nil then MapExtensionUISettings.achievements = { show = true, filter = true } end
	if MapExtensionUISettings.flags == nil then MapExtensionUISettings.flags = { lock = false } end
	if MapExtensionUISettings.tracking == nil then MapExtensionUISettings.tracking = { show = true } end
	if MapExtensionUISettings.options == nil then MapExtensionUISettings.options = { checkVersion = true, rareNotification = true, rareFilter = true } end
end

function MapExtension.AE.OnSwitchMap(flag)
	MapExtension.AE.UI.MapTexture.active = iif(flag == nil, 1 - MapExtension.AE.UI.MapTexture.active, flag)
	MapExtension.AE.UI.MapTexture[MapExtension.AE.UI.MapTexture.active]:SetVisible(true)
	MapExtension.AE.UI.MapTexture[1 - MapExtension.AE.UI.MapTexture.active]:SetVisible(false)
end

function MapExtension.AE.ToggleWindow()
	local unitDetail = Inspect.Unit.Detail("player")
	if unitDetail ~= nil and MapExtension.Zones[unitDetail.zone] ~= nil then
		MapExtension.AE.UI.MapTexture.active = MapExtension.Zones[unitDetail.zone].map
	end
	if not MapExtension.AE.firstLoad then
		MapExtension.Menu.Tracking.Scan()
		MapExtension.AE.firstLoad = true
	end

	MapExtension.AE.Visible = not MapExtension.AE.Visible
	MapExtension.Menu.Achievements.ToggleWindow(false)
	MapExtension.Menu.Tracking.ToggleWindow(false)
	MapExtension.AE.CoordinatesChanged()
	MapExtension.AE.OnSwitchMap(MapExtension.AE.UI.MapTexture.active)
	MapExtension.AE.UI.Window:SetVisible(MapExtension.AE.Visible)
end

function MapExtension.AE.CoordinatesChanged()
	for i = 1, 21 do
		local name = iif(i == 21, "player", string.format("group%.2d", i))
		local unitDetail = Inspect.Unit.Detail(name)
		local visible = unitDetail ~= nil and unitDetail.coordX ~= nil and unitDetail.coordZ ~= nil and MapExtension.Zones[unitDetail.zone] ~= nill
		if MapExtension.AE.Visible then
			MapExtension.AE.UI.MapTexture[0]:SetVisibleMark(name, visible and MapExtension.Zones[unitDetail.zone].map == 0)
			MapExtension.AE.UI.MapTexture[1]:SetVisibleMark(name, visible and MapExtension.Zones[unitDetail.zone].map == 1)
			if visible then MapExtension.AE.UI.MapTexture[MapExtension.Zones[unitDetail.zone].map]:SetMarkProperties(name, { x = unitDetail.coordX or 0, y = unitDetail.coordZ or 0 }, unitDetail.name) end
		end
		if i == 21 and visible then
			MapExtension.AE.Coordinates = { x = unitDetail.coordX, y = unitDetail.coordZ }
			if not MapExtension.AE.CoordinatesType then MapExtension.AE.ShowCoordinates(MapExtension.AE.Coordinates) end
			if MapExtension.AE.Visible and MapExtensionUISettings.flags.lock and (math.abs(MapExtension.AE.Coordinates.x - MapExtension.AE.OldCoordinates.x) >= 0.5 or math.abs(MapExtension.AE.Coordinates.y - MapExtension.AE.OldCoordinates.y) >= 0.5) then
				MapExtension.AE.OldCoordinates = MapExtension.AE.Coordinates
				MapExtension.AE.UI.MapTexture[MapExtension.Zones[unitDetail.zone].map]:SetPosition(MapExtension.AE.Coordinates.x, MapExtension.AE.Coordinates.y)
			end
		end
	end
end

function MapExtension.AE.ShowCoordinates(position)
	MapExtension.AE.UI.Coordinates:SetText("[ " .. math.floor(position.x) .. ", " .. math.floor(position.y) .. " ]")
end

function MapExtension.AE.LoadData()
	for map = 0, 1 do
		MapExtension.AE.UI.MapTexture[map]:AddMark("player", "player", { x = 0, y = 0, layer = 1000 }, { caption = "", type = MapExtension.Language.Player[MapExtension.AE.Language] })
		for i = 1, 20 do
			MapExtension.AE.UI.MapTexture[map]:AddMark(string.format("group%.2d", i), "group", { x = 0, y = 0, layer = 900 }, { caption = "", type = MapExtension.Language.Group[MapExtension.AE.Language] })
		end
	end
	MapExtension.AE.UI.MapTexture[0]:UpdateMarks()
	MapExtension.AE.UI.MapTexture[1]:UpdateMarks()
end

function MapExtension.AE.FilterMarks(ctrl, param)
	MapExtensionUISettings.achievements[param] = ctrl.checkbox:GetChecked()
	MapExtension.AE.ApplyFilterMarks()
end

function MapExtension.AE.ApplyFilterMarks()
	for dk, dv in pairs(MapExtension.Data) do
		for k, v in ipairs(dv.Data) do
			MapExtension.AE.UI.MapTexture[0]:SetVisibleMark(dk .. k, ifnull(MapExtensionUISettings.achievements[dk], false) and ifnull(MapExtensionUISettings.achievements.show, false) and (not MapExtensionUISettings.achievements.filter or not MapExtension.Achievement[dk].List[v.name[MapExtension.AE.Language]]))
			MapExtension.AE.UI.MapTexture[1]:SetVisibleMark(dk .. k, ifnull(MapExtensionUISettings.achievements[dk], false) and ifnull(MapExtensionUISettings.achievements.show, false) and (not MapExtensionUISettings.achievements.filter or not MapExtension.Achievement[dk].List[v.name[MapExtension.AE.Language]]))
		end
	end
end

function MapExtension.AE.TrackingChange(ctrl, param)
	MapExtensionUISettings.tracking[param] = ctrl.checkbox:GetChecked()
	MapExtension.AE.ApplyTrackingFilter()
end

function MapExtension.AE.ApplyTrackingFilter()
	for dk, dv in pairs(MapExtension.TrackList) do
		for k, v in pairs(dv.Data) do
			MapExtension.AE.UI.MapTexture[0]:SetVisibleMark(v.name.English, ifnull(MapExtensionUISettings.tracking[v.name.English], false) and ifnull(MapExtensionUISettings.tracking[dk], false) and MapExtensionUISettings.tracking.show)
			MapExtension.AE.UI.MapTexture[1]:SetVisibleMark(v.name.English, ifnull(MapExtensionUISettings.tracking[v.name.English], false) and ifnull(MapExtensionUISettings.tracking[dk], false) and MapExtensionUISettings.tracking.show)
		end
	end
end