function MapExtension.Menu.Tracking.Init(parent)
	if MapExtensionTrackingResources == nil then MapExtensionTrackingResources = {} end
	MapExtension.Menu.Tracking.ScanList = {}
	MapExtension.Menu.Tracking.ScanListTranslate = {}
	MapExtension.Menu.Tracking.Marks = {}

	MapExtension.Menu.Tracking.window = MapExtension.GUI.CreateFrame(parent, "CENTER", 12, -75, 200, 170, 200, MapExtension.AE.UI.Window)
	MapExtension.Menu.Tracking.window:SetVisible(false)

	MapExtension.GUI.CreateSimpleTexture(MapExtension.Menu.Tracking.window, 0, 0, 200, 12, 200, "img/tooltip200-top.png", "TOPLEFT")
	MapExtension.GUI.CreateSimpleTexture(MapExtension.Menu.Tracking.window, 0, 0, 200, 26, 200, "img/tooltip200-bottom.png", "BOTTOMLEFT")
	MapExtension.Menu.Tracking.background = MapExtension.GUI.CreateSimpleTexture(MapExtension.Menu.Tracking.window, 0, 12, 200, 132, 200, "img/tooltip200-middle.png", "TOPLEFT")
	MapExtension.GUI.CreateSimpleTexture(MapExtension.Menu.Tracking.background, 5, 30, 200, 5, 200, "img/tooltip-separator.png", "TOPLEFT")

	MapExtension.GUI.CreateText(MapExtension.Menu.Tracking.background, "TOPLEFT", 20, 5, MapExtension.Language.ResourceTracking[MapExtension.AE.Language])
	MapExtension.GUI.CreateCheckbox(MapExtension.Menu.Tracking.background, "TOPLEFT", 13, 40, 200, MapExtension.Language.ShowResources[MapExtension.AE.Language], MapExtension.AE.TrackingChange, "show", MapExtensionUISettings.tracking.show)

	MapExtension.Menu.Tracking.menus = {}
	local i = 0
	for dk, dv in pairs(MapExtension.TrackList) do
		MapExtension.Menu.Tracking.menus[dk] = { line = MapExtension.GUI.CreateHoveredCheckbox(MapExtension.Menu.Tracking.background, "TOPLEFT", 13, 70 + i * 20, 174, 19, 200, dv.Name[MapExtension.AE.Language], MapExtension.AE.TrackingChange, MapExtension.Menu.Tracking.ShowSubmenu, dk, MapExtensionUISettings.tracking[dk]) }

		MapExtension.Menu.Tracking.menus[dk].frame = MapExtension.GUI.CreateFrame(MapExtension.Menu.Tracking.window, "TOPLEFT", 0, 0, 250, 45, 300, MapExtension.AE.UI.Window)
		MapExtension.Menu.Tracking.menus[dk].frame:SetVisible(false)
		MapExtension.GUI.CreateSimpleTexture(MapExtension.Menu.Tracking.menus[dk].frame, 0, 0, 250, 12, 200, "img/tooltip250-top.png", "TOPLEFT")
		MapExtension.GUI.CreateSimpleTexture(MapExtension.Menu.Tracking.menus[dk].frame, 0, 0, 250, 26, 200, "img/tooltip250-bottom.png", "BOTTOMLEFT")
		MapExtension.Menu.Tracking.menus[dk].background = MapExtension.GUI.CreateSimpleTexture(MapExtension.Menu.Tracking.menus[dk].frame, 0, 12, 250, 7, 200, "img/tooltip250-middle.png", "TOPLEFT")

		local c = 0
		for k, v in ipairs(dv.Data) do
			MapExtension.GUI.CreateCheckbox(MapExtension.Menu.Tracking.menus[dk].background, "TOPLEFT", 13, 1 + c, 200, v.name[MapExtension.AE.Language], MapExtension.AE.TrackingChange, v.name.English, MapExtensionUISettings.tracking[v.name.English], v.icon)
			MapExtension.Menu.Tracking.ScanList[v.name[MapExtension.AE.Language]] = { name = v.name.English, category = dk, field = MapExtension.GUI.CreateText(MapExtension.Menu.Tracking.menus[dk].background, "TOPRIGHT", -20, 1 + c), count = 0, icon = v.icon }
			MapExtension.Menu.Tracking.ScanListTranslate[v.name.English] = v.name[MapExtension.AE.Language]
			c = c + 20
		end
		MapExtension.Menu.Tracking.menus[dk].frame:SetHeight(41 + c)
		MapExtension.Menu.Tracking.menus[dk].background:SetHeight(3 + c)
		i = i + 1
	end

	MapExtension.AE.UI.Window.Event.Move = function() MapExtension.Menu.Tracking.SetSubmenuPosition(MapExtension.Menu.Tracking.SelectedSubmenu) end
	MapExtension.AE.UI.Window.Event.Size = function() MapExtension.Menu.Tracking.SetSubmenuPosition(MapExtension.Menu.Tracking.SelectedSubmenu) end

	for k, v in pairs(MapExtensionTrackingResources) do
		for rk, rv in pairs(v.resources) do
			local name = MapExtension.Menu.Tracking.ScanListTranslate[rk]
			MapExtension.Menu.Tracking.Marks[k] = MapExtension.AE.UI.MapTexture[v.map]:AddMark(rk, "resource", { x = v.x, y = v.z }, { list = v.resources, translate = MapExtension.Menu.Tracking.ScanListTranslate }, ifnull(MapExtensionUISettings.tracking[rk], false) and ifnull(MapExtensionUISettings.tracking[MapExtension.Menu.Tracking.ScanList[name].category], false) and MapExtensionUISettings.tracking.show)
			MapExtension.Menu.Tracking.ScanList[name].count = MapExtension.Menu.Tracking.ScanList[name].count + 1
		end
	end

	for k, v in pairs(MapExtension.Menu.Tracking.ScanList) do
		v.field:SetText("" .. v.count)
	end
end

function MapExtension.Menu.Tracking.Remove(handle, elements)
	for k, v in pairs(elements) do
		for pk, pv in ipairs(MapExtension.Menu.Tracking.PointList) do
			if k == pv.id then
				MapExtension.Menu.Tracking.Marks[pv.position].ChangeTexture()
				table.remove(MapExtension.Menu.Tracking.PointList, pk)
				return
			end
		end
	end
end

function MapExtension.Menu.Tracking.Add(handle, elements)
	for k, element in pairs(Inspect.Map.Detail(elements)) do
		MapExtension.Menu.Tracking.AddElement(element)
	end
end

function MapExtension.Menu.Tracking.Scan()
	for k, element in pairs(Inspect.Map.Detail(Inspect.Map.List())) do
		MapExtension.Menu.Tracking.AddElement(element)
	end
end

function MapExtension.Menu.Tracking.AddElement(element)
	if MapExtension.Menu.Tracking.ScanList[element.description] ~= nil then
		local zone = MapExtension.Zones[Inspect.Unit.Detail("player").zone]
		local name = MapExtension.Menu.Tracking.ScanList[element.description].name
		if zone ~= nil then
			local position = zone.map .. "." .. math.floor(element.coordX) .. "." .. math.floor(element.coordY) .. "." .. math.floor(element.coordZ)
			if MapExtensionTrackingResources[position] == nil then 
				MapExtensionTrackingResources[position] = { map = zone.map, x = math.floor(element.coordX), y = math.floor(element.coordY), z = math.floor(element.coordZ), resources = {} }
				MapExtension.Menu.Tracking.Marks[position] = MapExtension.AE.UI.MapTexture[zone.map]:AddMark(name, "resource", { x = MapExtensionTrackingResources[position].x, y = MapExtensionTrackingResources[position].z }, nil, ifnull(MapExtensionUISettings.tracking[name], false) and ifnull(MapExtensionUISettings.tracking[MapExtension.Menu.Tracking.ScanList[element.description].category], false) and MapExtensionUISettings.tracking.show)
			end
			if MapExtensionTrackingResources[position].resources[name] ~= true then
				MapExtensionTrackingResources[position].resources[name] = true
				MapExtension.Menu.Tracking.Marks[position].data = { list = MapExtensionTrackingResources[position].resources, translate = MapExtension.Menu.Tracking.ScanListTranslate }
				MapExtension.Menu.Tracking.ScanList[element.description].count = MapExtension.Menu.Tracking.ScanList[element.description].count + 1
				MapExtension.Menu.Tracking.ScanList[element.description].field:SetText("" .. MapExtension.Menu.Tracking.ScanList[element.description].count)
			end
			table.insert(MapExtension.Menu.Tracking.PointList, { id = element.id, position = position })
			MapExtension.Menu.Tracking.Marks[position].ChangeTexture(MapExtensionAddon.identifier, MapExtension.Menu.Tracking.ScanList[element.description].icon, 17, 17)
		end
	end
end

function MapExtension.Menu.Tracking.ToggleWindow(flag)
	MapExtension.Menu.Tracking.ShowSubmenu(nil, nil, nil)
	if flag == nil then flag = not MapExtension.Menu.Tracking.window:GetVisible() end
	MapExtension.Menu.Tracking.window:SetVisible(flag)
end

function MapExtension.Menu.Tracking.ShowSubmenu(ctrl, param, value)
	if MapExtension.Menu.Tracking.SelectedSubmenu ~= nil then
		MapExtension.Menu.Tracking.menus[MapExtension.Menu.Tracking.SelectedSubmenu].frame:SetVisible(false)
		MapExtension.Menu.Tracking.menus[MapExtension.Menu.Tracking.SelectedSubmenu].line.SetHighlight(false)
	end
	if param ~= nil then
		MapExtension.Menu.Tracking.SetSubmenuPosition(param)
		MapExtension.Menu.Tracking.menus[param].frame:SetVisible(true)
		MapExtension.Menu.Tracking.menus[param].line.SetHighlight(true)
	end
	MapExtension.Menu.Tracking.SelectedSubmenu = param
end

function MapExtension.Menu.Tracking.SetSubmenuPosition(param)
	if param ~= nil then
		MapExtension.Menu.Tracking.menus[param].frame:ClearPoint("TOPLEFT")
		MapExtension.Menu.Tracking.menus[param].frame:SetPoint("TOPLEFT", MapExtension.Menu.Tracking.menus[param].line, "TOPLEFT", iif(MapExtension.AE.UI.Window:GetLeft() + MapExtension.AE.UI.Window:GetWidth() / 2 < UIParent:GetWidth() / 2, 159, -235), iif(MapExtension.AE.UI.Window:GetTop() + MapExtension.AE.UI.Window:GetHeight() * .75 < UIParent:GetHeight() / 2, -10, 43 - MapExtension.Menu.Tracking.menus[param].frame:GetHeight()))
	end
end